;;; -*- Mode :Lisp; Package: CL-USER; Syntax: Common-Lisp; Base: 10; -*-

;;;; Following is the .system file used at TMC for the *Lisp Simulator.
;;;; You should be able to copy it verbatim, changing only the physical
;;;; host (aquinas)

;;;; -*- Mode: LISP; Syntax: Common-Lisp; Package: USER; Base: 10; -*-
;
;(fs:set-logical-pathname-host
;  "STARSIM"
;  :physical-host "aquinas"
;  :translations
;  '(("starlisp-simulator;*.*.*"         ">cm>starlisp>simulator>f19>*.*.*")
;    ("starlisp-simulator;**;*.*.*"         ">cm>starlisp>simulator>f19>**>*.*.*")
;    ))
;
;
;(SCT:SET-SYSTEM-SOURCE-FILE
;  'STARLISP-SIMULATOR-F19
;  "starsim:starlisp-simulator;defsys-f19.lisp")
;

;;;; This is the end of the .system file used at TMC.



(defsystem starlisp-simulator-f19

  (:default-pathname "starsim: starlisp-simulator;" :patchable nil)

  (:serial	      

   "zwei-hacks"

   "make-packages"
   "def-starlisp"
   "external-symbols"
   "import-export"
   "help"
   "external-defvars"

   "destructuring-bind"
   "portable-proclaim"
   "defstruct-interface"
   "defstruct-parsing"
   "portable-geometry-ops"
   "starlisp-setf"

   "geometries"

   "simulator-specification"
   "unportable-proclaim"

   "no-bang-bang"

   "definitions"
   "pvars"
   "simulator-proclaim"

   "port"
   "starlisp-compiler-vars"
   "macros"

   "pvar-array-pool"
   "context"

   "vp-sets"
   "vp-sets-implementation"
   "pvar-allocation"
   "stardefvars"
   "cold-boot"

   "genfunctions"

   "pref"

   "defstruct-output"

   "trivfunctions"
   "functions"

   "sim"

   "internal-addressing"
   "addressing"
   "send"
   "get"
   "arrays"
   "address-objects"
   "address-object-smashing"

   "ppp"

   "hypergrid"
   "bitblt"
   "advanced-functions"
   "portable-rank-and-sort"

   ;; Experimental features

   "vector-functions"
   "sequence-ops-internal"
   "sequence-ops"
   "rational-scanning"

   "defstruct-tests"
   "array-tests"

   "patches"

   ))
